--EXPLAIN (ANALYZE, BUFFERS)
WITH 
-------------make BDL and SLV the same thing-------------------------------------------------------
-------------assumes that left column has all unique packages in rlarp.pcore-----------------------
vu AS (
    SELECT * FROM ( VALUES
    ('BDL','SLV'),
    ('BDL','BDL'),
    ('PLT','PLT'),
    ('CSE','CSE')
    ) x(bdl,uom)
)
----------------add columns for a better understanding of what is otherwise implied----------------
,pc AS materialized (
    SELECT
         plist
        ,STLC 
        ,COALESCE(COLTIER,'') COLTIER 
        ,coalesce(BRANDING,'' ) branding
        ,COALESCE(ACCS ,'') ACCS
        ,COALESCE(SUFF,'') SUFFIX
        ----price 1 -----------------
        ,PCKG PCKG1
        ,1 VOLL1
        ,PCKG VOL1_UOM
        ,PACK VOL1_PRICE
        ----price 2 -----------------
        ,PCKG PCKG2
        ,1 VOLl2
        ,'PLT' VOL2_UOM
        ,MP VOL2_PRICE
        ----price 3 -----------------
        ,'PLT' PCKG3
        ,1 VOLL3
        ,'PLT' VOL3_UOM
        ,BULK VOL3_PRICE
    FROM
        rlarp.PCORE P
)
--------------list unique colors per line-----------------------------------------------------------
,colors AS (
SELECT
     pc.plist
    ,pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
    ,string_agg( DISTINCT ltrim(rtrim(i.COLC)),', ') tclist
    ,jsonb_agg( DISTINCT ltrim(rtrim(i.COLC))) clist
FROM    
    pc
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = pc.stlc
        AND i.COLTIER = pc.coltier
        --relax relationship to pick up any colors that we run for the mold and color tier
        --AND COALESCE(i.BRANDING,'') = pc.branding
        --AND COALESCE(i.ACCS,'') = pc.ACCS
        --AND COALESCE(i.SUFFIX,'') = pc.suffix
        AND APLNT <> 'I'
GROUP BY 
     pc.plist
    ,pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
)
-----------since joining to the item master will be differnt for the last bulk columm---------------
-----------must first pivot the data out then join based on the type of row-------------------------
,unpivot AS (
    SELECT  
        pc.plist
        ,pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,1 col
        ,pc.pckg1 pckg
        ,pc.vol1_uom vol_uom
        ,pc.voll1 vol_qty
        ,pc.vol1_price price
    FROM
        pc
    WHERE
        pc.vol1_price IS NOT null
    UNION
    SELECT
        pc.plist
        ,pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,2 col
        ,pc.pckg2 pckg
        ,pc.vol2_uom vol_uom
        ,pc.voll2 vol_qty
        ,pc.vol2_price price
    FROM
        pc
    WHERE
        pc.vol2_price IS NOT null
    UNION
    SELECT
        pc.plist
        ,pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,3 col
        ,pc.pckg3 pckg
        ,pc.vol3_uom vol_uom
        ,pc.voll3 vol_qty
        ,pc.vol3_price price
    FROM
        pc
    WHERE
        pc.vol3_price IS NOT null
)
--SELECT DISTINCT pckg FROM unpivot;
--link to actual part numbers, tag the sequence so a single item can be chosen-----
,items_init AS (
SELECT 
     up.plist
    ,up.stlc
    ,up.coltier
    ,up.branding
    ,up.accs
    ,up.suffix
    ,up.pckg
    --retain this column to re-pivot back to original format
    ,up.col
    ,up.vol_uom
    ,up.voL_qty
    ,up.price
    ,row_number() OVER (PARTITION BY up.plist, up.stlc, up.coltier, up.branding, up.accs, up.suffix, up.pckg, up.col, up.vol_uom ORDER BY item ASC) seq
    ,item
    --subquery option is not performant at all
FROM    
    unpivot up
    ----make all the BDL units of measure BDL and also SLV with intentional duplication 
    ----becusae some defaults units on itemm have SLV and not BDL, but still need a join
    LEFT OUTER JOIN vu ON
        vu.bdl = up.pckg
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = up.stlc
        --AND i.COLTIER = pc.coltier
        AND i.uomp ? vu.uom
        AND COALESCE(i.BRANDING,'') = up.branding
        AND COALESCE(i.ACCS,'') = up.ACCS
        AND COALESCE(i.SUFFIX,'') = up.suffix
        AND APLNT <> 'I'
)
SELECT * FROM items_init WHERE stlc = 'TRV55420'
------compile all the conversions into a single json object----------------------
--,items AS (
--    SELECT
--        jsonb_agg( DISTINCT 
--            jsonb_build_object(
--                'partn', item
--                ,'fu', vol_uom
--                ,'tu','PC'
--            )
--        ) conv
--    FROM 
--        items_init 
--    WHERE 
--        seq = 1
--        AND COALESCE(item,'') <> ''
--)
----do the conversion-------------------------------------------------------------
--, conversion AS (
--    SELECT
--        rslt.* 
--    FROM
--        items 
--        JOIN LATERAL rlarp.uom_array(conv) rslt ON true
--)
------join conversion back to data initial part link------------------------------
--,joinback_init AS (
--SELECT 
--    i.stlc
--    ,i.coltier
--    ,i.branding
--    ,i.accs
--    ,i.suffix
--    ,i.pckg
--    ,i.col
--    ,i.vol_uom
--    ,i.vol_qty
--    ,i.price
--    ,c.nm
--    ,c.dm
--    ,l.clist
--FROM
--    items_init i
--    LEFT OUTER JOIN conversion c ON
--        c.p = i.item
--        AND c.f = i.vol_uom
--    NATURAL JOIN colors l
--WHERE
--    i.seq = 1
--ORDER BY
--     i.stlc
--    ,i.coltier
--    ,i.col
--)
------aggregate everything offered for the price point----------------------------
--,agg_levels AS (
--    SELECT
--         stlc
--        ,string_agg(DISTINCT coltier ,', ') FILTER (WHERE clist IS NOT NULL) coltier
--        ,string_agg(DISTINCT branding,', ') branding
--        -------replace blank with 'none'--------------
--        ,regexp_replace(string_agg(DISTINCT accs    ,', '),'^,','none,','g') accs
--        ,string_agg(DISTINCT suffix  ,', ') suffix
--        ,pckg
--        ,col
--        ,vol_uom
--        ,voL_qty
--        ,nm
--        ,dm
--        ,price
--        -----convert json array to a plain text representation as well as remove nulls------
--        ,regexp_replace(jsonb_arr_aggcd(clist)::text,'["\[\]]|null, ','','g') clist
--    FROM
--        joinback_init
--    GROUP BY
--        stlc
--        ,pckg
--        ,col
--        ,vol_uom
--        ,vol_qty
--        ,nm
--        ,dm
--        ,price
--)
--,seq_levels AS (
--    SELECT 
--        stlc||'.'||pckg||'.'||col||'.'||to_char(row_number() OVER (PARTITION BY stlc, col ORDER BY price ASC),'FM00') lookup
--        ,stlc
--        ,coltier
--        ,branding
--        ,accs
--        ,suffix
--        ,pckg
--        ,clist
--        ,col
--        ,vol_uom
--        ,vol_qty
--        ,nm
--        ,dm
--        ,price
--    FROM 
--        agg_levels
--)
--SELECT * FROM seq_levels
